/**
 * Quadrilatero
 *      float L1, L2, L3, L4 
 *      getPerimetro(); // soma de todos os lados
 *
 *      Retangulo
 *      // definir 2 lados no contrutor 
 *      getArea(); 
 *
 *      Quadrado
 *      // definir 1 lado
 */
#include <iostream>
using namespace std;
// Classe Abstrata
class Quadrilatero {
protected:
    float L1;
    float L2;
    float L3;
    float L4;
public:
    Quadrilatero(float L1, float L2, float L3, float L4):
        L1(L1), L2(L2), L3(L3), L4(L4) {}
    
    float getPerimetro() {
        return L1 + L2 + L3 + L4;
    }
    
    virtual float getArea() = 0; // Método Virtual Puro
}; 

class Retangulo : public Quadrilatero {
public:
    Retangulo( float L1, float L2 ) : 
        Quadrilatero( L1, L1, L2, L2 ){}
    virtual float getArea() {
        return L1 * L3;
    }
}; 
class Quadrado : public Retangulo {
public:
    Quadrado( float L1 ) : Retangulo( L1, L1 ){}
};

int main() {
    Quadrilatero * q = new Quadrado( 4 );
    cout << "Área: " << q->getArea() << endl;  
    
    q = new Retangulo( 4, 5 );
    cout << "Área: " << q->getArea() << endl;  
    
}
